#include <stdio.h>
#include <stdlib.h>

typedef struct nodo {
	int llave;
	struct nodo *izq;
	struct nodo *der;
} NODO;

NODO * crea_nodo( int llave )
{
	NODO * nodo;

	nodo = (NODO *) malloc( sizeof(NODO) );
	if( nodo == NULL ) {
		fprintf( stderr, "ERROR: No hay memoria\n" );
		exit(1);
	}

	nodo -> llave = llave;
	nodo -> der = NULL;
	nodo -> izq = NULL;

	return nodo;
}

void recorrer_en_orden( NODO * pnodo )
{
	if( pnodo != NULL ) {
		recorrer_en_orden( pnodo->izq );
		printf("%d\n", pnodo -> llave );
		recorrer_en_orden( pnodo->der );
	}
}

void liberar_memoria( NODO * pnodo )
{
	if( pnodo != NULL ) {
		liberar_memoria( pnodo->izq );
		liberar_memoria( pnodo->der );
		free( pnodo );
		pnodo = NULL;
	}
}

NODO * busqueda_iterativa( NODO *pnodo, int k )
{
	while( pnodo != NULL && k != pnodo->llave ) {
		if( k < pnodo->llave )
			pnodo = pnodo->izq;
		else 
			pnodo = pnodo->der;
	}
	return pnodo;
}


int main( )
{
	NODO *pnodo;
	NODO *arbol;

	arbol = crea_nodo( 6 );

	pnodo = crea_nodo( 5 );
	arbol -> izq = pnodo;

	pnodo = crea_nodo( 2 );
	arbol -> izq -> izq = pnodo;

	pnodo = crea_nodo( 5 );
	arbol -> izq -> der  = pnodo;

	pnodo = crea_nodo( 7 );
	arbol -> der  = pnodo;

	pnodo = crea_nodo( 8 );
	arbol -> der -> der  = pnodo;

	recorrer_en_orden( arbol );

	pnodo = busqueda_iterativa( arbol, 8 );
	if( pnodo != NULL ){
		printf("Encontré el nodo %d\n", pnodo->llave );
	}
	else{
		printf("No encontré el nodo 8\n" );
	} 

	pnodo = busqueda_iterativa( arbol, 10 );
	if( pnodo != NULL ){
		printf("Encontré el nodo %d\n", pnodo->llave );
	}
	else{
		printf("No encontré el nodo 10\n" );
	} 

	// Hay que liberar la memoria del árbol
	liberar_memoria( arbol );
	return 0;
}		
