#include <stdio.h>

typedef struct punto {
	int x, y;
} PUNTO;

int prueba( PUNTO *a, PUNTO *b, PUNTO *c )
{
	int x1, x2;
	int y1, y2;
	int v;

	x1 = c->x - a->x;
	y1 = c->y - a->y;

	x2 = b->x - a->x;
	y2 = b->y - a->y;

	v = x1*y2 - y1*x2;

	if( v>0 )	
		return 1;
	else
		return -1;

} 

void ordenamiento_por_insercion( PUNTO A[], int n1, int n2 )
{
	int i, j;
	PUNTO key;

	for( j=n1+1; j<n2; j++ ){
		key.x = A[j].x;
		key.y = A[j].y;
		// Inserta A[j] en la secuencia ordenada A[1..j-1]
		i = j - 1;
		while( i >= n1 && prueba( &A[i], &key, &A[0] )>0 ) {
			A[i+1].x = A[i].x;
			A[i+1].y = A[i].y;
			i--;
		}
		A[i+1].x = key.x; 
		A[i+1].y = key.y; 
	}
}

int escaneo_de_Graham( PUNTO P[], int n )
{
	int k;
	int i, min;
	int tmp;

	if( n==1 ) {
		k=1;
		return k;
	}

	// Buscamos el punto con la y mínima
	min = 0;
	for( i=1; i<n; i++ ) {
		if ( P[i].y < P[min].y )
			min = i; 
	}

	// Si hay varios de esos puntos, escogemos
	// el de x mínima
	for( i=0; i<n; i++ ) {
		if ( P[i].y == P[min].y && P[i].x < P[min].x ) 
			min = i; 
	}
	/** Cambio los puntos 0 y min **/
	tmp = P[0].x;
	P[0].x = P[min].x;
	P[min].x = tmp;

	tmp = P[0].y;
	P[0].y = P[min].y;
	P[min].y = tmp;

	ordenamiento_por_insercion( P, 1, n );
	/** **/
	k=1; 
	for( i=2; i<n; i++ ){
		while( prueba( &P[k-1], &P[k], &P[i] ) > 0 ){
			k--;
			// printf("k=%d\n", k );
		}
		k++;
		/** Cambio los puntos i y k **/
		tmp = P[i].x;
		P[i].x = P[k].x;
		P[k].x = tmp;

		tmp = P[i].y;
		P[i].y = P[k].y;
		P[k].y = tmp;
	} 

	return k+1;
}
	

int main( )
{
	PUNTO P[7] = { {6,1}, {1,2}, {3,4}, {2,9}, {4,1}, {6,5}, {9, 7} };
	// PUNTO P[6] = { {6,1}, {1,2}, {3,4}, {2,9}, {6,5}, {9, 7} };

	int i, k;

	// for( i=0; i<7; i++ )
	// 	printf("%d %d\n", P[i].x, P[i].y );

	k = escaneo_de_Graham( P, 7 );

	for( i=0; i<k; i++ )
		printf("%d %d\n", P[i].x, P[i].y );

	return 0;
}
